/* Arraychar.p -- type-specific functions for class Arraychar

Author:
	K. E. Gorlen
	Bg. 12A, Rm. 2017
	Computer Systems Laboratory
	Division of Computer Research and Technology
	National Institutes of Health
	Bethesda, Maryland 20892
	Phone: (301) 496-5363
	uucp: {decvax!}seismo!elsie!cecil!keith
	September, 1985

Function:
	
Type-specific functions for class Arraychar, such as hash() and
printOn().  Generic functions are generated from the m4 template file
Array.c.m4.

WARNING -- Make changes to the .p or .m4 files, not to the .c file
they generate.

Modification History:

26-Feb-87	K. E. Gorlen

1.  Quote preprocessor commands for compatibility with 4.2BSD m4.

28-Oct-86	K. E. Gorlen

1.  Made generic by using m4 macros.

07-Oct-86	S. M. Orlow

1.  Adapted from Array.h and Arrayimp.h because the macros were
    defeating the preprocessor.
*/

`#include' "Arraychar.h"
`#include' "oopsconfig.h"
`#include' <libc.h>
`#include' "oopsIO.h"

`#define'	THIS	Arraychar
`#define'	BASE	Collection
DEFINE_CLASS(Arraychar,Collection,1,NULL,NULL);

static int charCmp(char* a, char* b)
{
	return *(unsigned char*)a - *(unsigned char*)b;
}

static union hash_char_mask {
	UNSIGNED in[sizeof(int)];
	char ch[sizeof(int)*sizeof(int)];
	hash_char_mask();
} mask;

static hash_char_mask::hash_char_mask()
{
	for (register UNSIGNED i=0; i<sizeof(int); i++) {
		for (register UNSIGNED j=0; j<sizeof(int); j++) ch[sizeof(int)*i+j] = j<i ? 0xff : 0;
	}
}

UNSIGNED THIS::hash()
{
	register UNSIGNED h = sz;
`#ifdef' LOG2_INT
	register UNSIGNED i = sz >> LOG2_INT;
`#else'
	register UNSIGNED i = sz/sizeof(int);
`#endif'
	register UNSIGNED* vv = (UNSIGNED*)v;
	while (i--) h ^= *vv++;
`#ifdef' LOG2_INT
	if ((i = sz&(sizeof(int)-1)) != 0)
`#else'
	if ((i = sz%sizeof(int)) != 0)
`#endif'
		h ^= *vv & mask.in[i];
	return h;
}

void THIS::printOn(ostream& strm)
{
	strm << Arraychar() << "[";
	for (register UNSIGNED i=0; i<sz; i++) {
		strm << "\t" << form("0x%.2x",(unsigned int)(unsigned char)v[i]);
	}
	strm << "]\n";
}

THIS::THIS(istream& strm, THIS& where)
{
	this = &where;
	strm >> sz;
	v = new char[sz];
	for (register UNSIGNED i =0; i<sz; i++) { int _i; strm >> _i; v[i] = _i; }
}

void THIS::storer(ostream& strm)
{
	Object::storer(strm);
	strm << sz << " ";
	for (register UNSIGNED i=0; i<sz; i++) strm << (unsigned int)(unsigned char)v[i] << " ";
}

Arraychar::Arraychar(fileDescTy& fd, Arraychar& where)
{
	this = &where;
	readBin(fd,sz);
	v = new char[sz];
	readBin(fd,v,sz);
}

void Arraychar::storer(fileDescTy& fd) 
{
	Object::storer(fd);
	storeBin(fd,sz);
	storeBin(fd,v,sz);
}

ARRAYIMPLEMENT(Arraychar,char)
