#ifndef ARRAYOBIDH
#define ARRAYOBIDH

/* Arrayobid.h -- declarations for array of object pointers (object IDs)

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "Collection.h"

extern Class class_Arrayobid;

class Arrayobid: public Collection {
	obid* v;
	UNSIGNED sz;
	void AllocSizeErr();
	void IndexRangeErr();
public:
	Arrayobid(UNSIGNED size =CLTN_DEFAULT_CAPACITY);
	Arrayobid(const Arrayobid&);
	~Arrayobid()		{ delete v; }
	Arrayobid(fileDescTy&,Arrayobid&);
	Arrayobid(istream&,Arrayobid&);
	obid& elem(int i)	{ return v[i]; }
	bool operator!=(const Arrayobid& a)	{ return !(*this==a); }
	void operator=(const Arrayobid&);
	bool operator==(const Arrayobid&);
	obid& operator[](int i) {
		if ((unsigned)i >= sz) IndexRangeErr();
		return v[i];
	}
	virtual Collection& addContentsTo(Collection&);
	virtual obid& at(int i);
	virtual UNSIGNED capacity();
	virtual void deepenShallowCopy();
	virtual obid doNext(DoCltnPos&);
	virtual UNSIGNED hash();
	virtual const Class* isA();
	virtual bool isEqual(const Object&);
	virtual void printOn(ostream& strm);
	virtual void reSize(UNSIGNED);
	virtual UNSIGNED size();
	virtual void sort();
	virtual const Class* species();
	virtual void storer(fileDescTy&);
	virtual void storer(ostream&);
};

#endif
