#ifndef IDENTDICTH
#define IDENTDICTH 

/* IdentDict.h -- declarations for Identity Dictionary

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "Dictionary.h"

extern Class class_IdentDict;

class LookupKey;
class OrderedCltn;

class IdentDict: public Dictionary {
	virtual int findIndexOf(const Object&);
public:
	IdentDict(UNSIGNED size =CLTN_DEFAULT_CAPACITY);
	IdentDict(const IdentDict&);
	IdentDict(fileDescTy&,IdentDict&);
	IdentDict(istream&,IdentDict&);
	void operator=(const IdentDict&);
	virtual LookupKey& assocAt(const Object& key);
	virtual obid atKey(const Object& key);
	virtual obid atKey(const Object& key, const Object& newValue);
	virtual bool includesKey(const Object& key);
	virtual const Class* isA();
};

#endif
