#ifndef RANDOMH
#define RANDOMH 

/* Random.h -- declarations for pseudo-random number generator

Author:
	K. E. Gorlen
	Computer Systems Laboratory, DCRT
	National Institutes of Health
	Bethesda, MD 20892

Modification History:

*/

#include "Object.h"

extern Class class_Random;

class Random: public Object {
	long	randx;
public:
	Random();
	Random(long seed)		{ randx = seed; }
	Random(fileDescTy&,Random&);
	Random(istream&,Random&);
	float next();
	virtual obid	copy();			// { return shallowCopy(); }
	virtual void	deepenShallowCopy();	// {}
	virtual const Class* isA();
	virtual void printOn(ostream& strm);
	virtual void storer(fileDescTy&);
	virtual void storer(ostream&);
};

#endif
